<template>
  <div>
    <Form :handleSubmit=handleSubmit :error=error>
      <label for="secret">Your secret text</label>
      <input id="secret" type="text" placeholder="Type your secret here" required v-model=form.secret />
      <div class="row-container">
        <div>
          <label for="expireAfterViews">View limit</label>
          <input id="expireAfterViews" type="number" required min="1" v-model=form.expireAfterViews />
        </div>
        <div>
          <label for="expireAfter">Exp. in minutes</label>
          <input id="expireAfter" type="number" required min="1" :disabled=form.neverExpires v-model=form.expireAfter />
        </div>
      </div>
      <input id="neverExpires" type="checkbox" v-model=form.neverExpires />
      <label for="neverExpires">Never expires</label>
    </Form>
  </div>
</template>

<script>
  import { mapState, mapActions } from 'vuex';
  import Form from '../components/Form';

  export default {
    name: 'AddSecretContainer',
    components: { Form },
    data () {
      return {
        form: {
          secret: '',
          expireAfterViews: 1,
          expireAfter: 1,
          neverExpires: false
        }
      };
    },
    computed: mapState({
      error: state => state.error,
    }),
    methods: {
      ...mapActions(['createSecret']),
      async handleSubmit (evt) {
        evt.preventDefault();
        await this.createSecret({
          secret: this.form.secret,
          expireAfterViews: Number(this.form.expireAfterViews),
          expireAfter: this.form.neverExpires ? 0 : Number(this.form.expireAfter)
        });

        this.form.secret = '';
        this.form.expireAfterViews = 1;
        this.form.expireAfter = 1;
        this.form.neverExpires = false;
      }
    }
  }
  </script>
